码迷,mamicode.com
首页 > 其他好文 > 详细

Codeforces Round #396 (Div. 2) C. Mahmoud and a Message DP

时间:2017-03-25 13:18:47      阅读:208      评论:0      收藏:0      [点我收藏+]

标签:strong   test   blog   should   ice   ogr   condition   val   方案   

C. Mahmoud and a Message
 

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That‘s because this magical paper doesn‘t allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can‘t write character ‘a‘ on this paper in a string of length 3 or more. String "aa" is allowed while string "aaa" is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn‘t overlap. For example, if a1 = 2 and he wants to send string "aaa", he can split it into "a" and "aa" and use 2 magical papers, or into "a", "a" and "a" and use 3 magical papers. He can‘t split it into "aa" and "aa" because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings "ab", "abc" and "b" are substrings of string "abc", while strings "acb" and "ac" are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

  • How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don‘t overlap? Compute the answer modulo 109 + 7.
  • What is the maximum length of a substring that can appear in some valid splitting?
  • What is the minimum number of substrings the message can be spit in?

Two ways are considered different, if the sets of split positions differ. For example, splitting "aa|a" and "a|aa" are considered different splittings of message "aaa".

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, ..., a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Examples
input
3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
output
3
2
2
 
Note

In the first example the three ways to split the message are:

  • a|a|b
  • aa|b
  • a|ab

The longest substrings are "aa" and "ab" of length 2.

The minimum number of substrings is 2 in "a|ab" or "aa|b".

Notice that "aab" is not a possible splitting because the letter ‘a‘ appears in a substring of length 3, while a1 = 2.

 

题意

  给你一个字符串; 
     然后让你把这个字符串进行分割;形成若干个小的字符串; 
     字母都有一个数字V[i];表示这个字母能够存在于长度不超过v[i]的字符串内; 
     问你有多少种分法,这些分法中,最长的一部分有多长,分成的部分最少的有多少份

题解:

  dp[i][j]表示i位置向前组成长度j的一部分的方案数

     所有的方案就是dp[i][1~1000],最长的去max就行,最少有多少份,再取个dp

#include<bits/stdc++.h>
using namespace std;
#pragma comment(linker, "/STACK:102400000,102400000")
#define ls i<<1
#define rs ls | 1
#define mid ((ll+rr)>>1)
#define pii pair<LL,int>
#define MP make_pair
typedef long long LL;
const long long INF = 1e18;
const double Pi = acos(-1.0);
const int N = 1e3+10, mod = 1e9+7, inf = 2e9;

int dp[N][N],v[N],sum[N],n,mi[N][N],ans=1,dp2[N];
char a[N];
int main() {
    scanf("%d%s",&n,a+1);
    for(int i = 0; i < 26; ++i) scanf("%d",&v[i]);
    sum[0] = 1;
    int mx = 0;
    for(int i = 1; i <= n; ++i) {
        mi[i][i] = v[a[i] - a];
        for(int j = i+1; j <= n; ++j) {
            mi[i][j] = min(mi[i][j-1],v[a[j] - a]);
        }
    }
    for(int i = 1; i <= n; ++i) {
        dp[i][1] = sum[i-1];
        sum[i] = sum[i-1];
        dp2[i] = dp2[i-1] + 1;
        for(int j = 2; j <= i; ++j) {
            int tmp;
            if(mi[i-j+1][i] < j) tmp = 0;
            else tmp = 1;
           if(tmp) ans = max(ans,j);
            dp[i][j] = (1LL*tmp*sum[i-j]);
            sum[i] += dp[i][j];
            sum[i] %= mod;
            if(tmp) dp2[i] = min(dp2[i-j]+1,dp2[i]);
        }
    }
    printf("%d\n%d\n%d\n",sum[n],ans,dp2[n]);

    return 0;
}

 

Codeforces Round #396 (Div. 2) C. Mahmoud and a Message DP

标签:strong   test   blog   should   ice   ogr   condition   val   方案   

原文地址:http://www.cnblogs.com/zxhl/p/6616728.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!